#ifndef FUNCTIONLOAD_HEAD
#define FUNCTIONLOAD_HEAD

#include "v8.h"
#include <vector>

class regFunction {
public:
    regFunction(char *, v8::Handle<v8::FunctionTemplate>);
    regFunction(char *name, v8::Handle<v8::Value> (*func)(const v8::Arguments& args));
    ~regFunction();
    void registerToContext(v8::Persistent<v8::Context> context);
    char *name;
    v8::Handle<v8::FunctionTemplate> templ;
};

extern std::vector<regFunction> funclist;


#endif
