#ifndef KEY_HEAD
#define KEY_HEAD
#include "SDL_V8.h"

void KeyInit();
void KeyClose();

extern v8::Persistent<v8::FunctionTemplate> KeyConsttempl;
extern v8::Persistent<v8::ObjectTemplate> KeyConstInsttempl;

v8::Handle<v8::Value> GetKey(const v8::Arguments& args);
v8::Handle<v8::Value> IsKeyPressed(const v8::Arguments& args);
v8::Handle<v8::Value> IsAnyKeyPressed(const v8::Arguments& args);
v8::Handle<v8::Value> AreKeysLeft(const v8::Arguments& args);
v8::Handle<v8::Value> GetKeyString(const v8::Arguments& args);
void TS_SetKeyConstants(v8::Persistent<v8::Context> context);

#endif
