#include "scriptfs.h"
#include "t5.h"

using namespace std;
    //v8::HandleScope scopey;
	v8::Persistent<v8::FunctionTemplate> Filetempl;//   = *v8::FunctionTemplate::New();
	//v8::HandleScope scopey;
	v8::Persistent<v8::ObjectTemplate> FileInsttempl;// = *Filetempl->InstanceTemplate();

void FileInit(){
    Filetempl = *v8::FunctionTemplate::New();
    FileInsttempl = *Filetempl->InstanceTemplate();
}

void FileClose(){
    Filetempl.Dispose();
    FileInsttempl.Dispose();
}

TS_File::TS_File(const char *filename){
    //const char *filepath = string(TS_dirs.save).append(filename).c_str();
    //T5_file *file = T5_OpenFile(filepath);


};
/*
TS_File::TS_Fileq(const char *file){
    const char *filepath = string(TS_dirs.save).append(file).c_str();
	filestream = new fstream(filepath);
	string keybuffer;
	string buffer;
	 if (filestream->is_open())
		while (filestream->good()){
			keybuffer="";
            getline(*filestream, buffer);
			if(!buffer.empty()){
			//txt = buffer.c_str();
			//buffer.clear();
			unsigned int i = 0;
			size_t e = 0;

				while(i<buffer.size()){
					e = i;
					if((char)buffer.at(e)==(char)61){
						keys.push_back(keybuffer);
						i++;
						break;
					}
					else{
						keybuffer+=(char)buffer.at(e);
					}
					i++;
				}

				keybuffer.clear();

				while(i<buffer.size()){
					e=i;
					keybuffer+=(char)buffer.at(e);
					i++;
				}

				values.push_back(keybuffer);
				printf("value read from file: %s\n", keybuffer.c_str());
				}
			}
}
*/
const char *TS_File::Read(const char *key, bool verbose)
{
	//if(verbose) printf("reading key [%s]\n", key);
	for(unsigned int i = 0; i< keys.size(); i++){
		//if(verbose) printf("checking against key [%s]\n", string(keys[i]));
		if(keys[i]==string(key)){
			return values[i].c_str();
			break;
		}
	}
	return "<value not found!!!>";

}

v8::Handle<v8::Value> TS_FileRead(const v8::Arguments& args)
{
	//interpret the args so that they can be passes to drawText as a const char *
	std::stringstream text;
	text.str("");
	v8::String::AsciiValue str(args[0]);
		text<<*str;
	const std::string STR_text = text.str();
	const char* CSTR_text = STR_text.c_str();
	v8::Local<v8::Object> self = args.Holder();
	v8::Local<v8::External> wrap = v8::Local<v8::External>::Cast(self->GetInternalField(0));
	void* ptr = wrap->Value();
	return v8::String::New(static_cast<TS_File*>(ptr)->Read(CSTR_text, true));

}


v8::Handle<v8::Value> TS_OpenFile(const v8::Arguments& args)
{
	v8::TryCatch try_catch;
	v8::HandleScope loadfilescope;
	v8::String::AsciiValue error(try_catch.Exception());
	if(*error){
		printf("%s\n", *error);
	}
	v8::Handle<v8::ObjectTemplate> Fileproto = Filetempl->PrototypeTemplate();

	Fileproto->Set("read", v8::FunctionTemplate::New(TS_FileRead));
  v8::Handle<v8::Value> external;
  if(args.Length()<1){
	  printf("TS_OpenFile called with no parameters!");
	  return v8::Undefined();
  }
   //if (args[0]->IsExternal()) {
   // external = v8::Local<v8::External>::Cast(args[0]);
   //} else

  {
    std::stringstream text;
	text.str("");
	v8::String::Utf8Value str(args[0]);
	text<<*str;
	fstream fileS(text.str().c_str());
    TS_File *file = new TS_File(text.str().c_str());
    external = v8::External::New(file);

  }
  	FileInsttempl->SetInternalFieldCount(1);
	v8::Handle<v8::Function> Filector = Filetempl->GetFunction();
	v8::Local<v8::Object> Fileobj = Filector->NewInstance();
	Fileobj->SetInternalField(0, external);

	return loadfilescope.Close(Fileobj);
}

TS_File::~TS_File() {
    delete filestream;
}
