
#include <iostream>
#include <fstream>
#include <sstream>
#include <string>
#include <vector>
#include "SDL_V8.h"
#include "openscript.h"
#include "opengame.h"

#ifndef FS_HEAD
#define FS_HEAD
using namespace std;


extern v8::Persistent<v8::FunctionTemplate> Filetempl;
extern v8::Persistent<v8::ObjectTemplate> FileInsttempl;

void FileInit();
void FileClose();

class TS_File{
public:
	TS_File(fstream);
	TS_File(const char*);
	~TS_File();
	const char *Read(const char *, bool);
	void close();
	void flush();
	bool write();
	fstream* filestream;
private:
	vector<string> keys;
	vector<string> values;
};

v8::Handle<v8::Value> TS_OpenFile(const v8::Arguments& args);
v8::Handle<v8::Value> TS_FileRead(const v8::Arguments& args);

#endif
