#ifndef OPENGAME_HEAD
#define OPENGAME_HEAD

#include <string>
using namespace std;

struct TS_Directories {
    string root;
    string image;
    string font;
    string script;
    string sound;
    string map;
    string other;
    string save;
    string spriteset;
    string animation;
    string windowstyle;
    string system;
    string systemscript;
} ;

struct TS_Config {
    string gamename;
    string mainscript;
    int screenwidth;
    int screenheight;
    int soundchannels;
    bool fullscreen;
    const char *systemfont;
    const char *systemttffont;
    const char *systemwindowstyle;
    const char *systemarrow;
    const char *systemuparrow;
    const char *systemdownarrow;
} ;

extern TS_Directories TS_dirs;

extern TS_Config TS_conf;

void opengame(const char *Rfile);
void setDirectories(string basedir);
void setConfig(string);

#endif
